Attribute VB_Name = "Vector"
Option Explicit

Public Type Vector3d
    x As Single
    y As Single
    z As Single
End Type

Public Function vectorScale(v1 As Vector3d, s As Single) As Vector3d
With vectorScale
    .x = v1.x * s
    .y = v1.y * s
    .z = v1.z * s
End With
End Function

Public Function createVector(a As Single, b As Single, c As Single) As Vector3d
    With createVector
        .x = a
        .y = b
        .z = c
    End With
End Function

Public Function vectorAbs(v1 As Vector3d) As Single
    With v1
        vectorAbs = .x * .x + .y * .y + .z * .z
    End With
    vectorAbs = Sqr(vectorAbs)
End Function

Public Function vectorUnit(v1 As Vector3d) As Vector3d
    'unit vector = v/|v|
    Dim abvect As Single
    abvect = vectorAbs(v1)
    If abvect <> 0 Then
        vectorUnit = vectorScale(v1, 1 / abvect)
    End If
    
End Function

Public Function vectorDot(v1 As Vector3d, v2 As Vector3d) As Single
    vectorDot = v1.x * v2.x + v1.y * v2.y + v1.z * v2.z
End Function

Public Function vectorCross(v1 As Vector3d, v2 As Vector3d) As Vector3d
    With vectorCross
        .x = v1.y * v2.z - v1.z * v2.y
        .y = v1.z * v2.x - v1.x * v2.z
        .z = v1.x * v2.y - v1.y * v2.x
    End With
End Function

Public Function vectorSub(v1 As Vector3d, v2 As Vector3d) As Vector3d

With vectorSub
    .x = v1.x - v2.x
    .y = v1.y - v2.y
    .z = v1.z - v2.z
End With

End Function

Public Function vectorComponentParallel(v1 As Vector3d, ref As Vector3d) As Vector3d
    'ref MUST be a unit vector. returns v1's component parallel to ref
    vectorComponentParallel = vectorScale(ref, vectorDot(v1, ref))
End Function

Public Function vectorComponentPerpendicular(v1 As Vector3d, ref As Vector3d) As Vector3d
    'ref MUST be a unit vector. returns v1's component perpendicular to ref
    vectorComponentPerpendicular = vectorSub(v1, vectorComponentParallel(v1, ref))
End Function

Public Function vectorDistance(v1 As Vector3d, v2 As Vector3d) As Single
    vectorDistance = vectorAbs(vectorSub(v1, v2))
End Function

Public Function vectorZero(v As Vector3d) As Boolean
    If (v.x = 0 And v.y = 0 And v.z = 0) Then vectorZero = True
End Function

Public Function vectorIntEqual(v1 As Vector3d, v2 As Vector3d) As Boolean
If (Int(v1.x) = Int(v2.x) And Int(v1.y) = Int(v2.y) And Int(v1.z) = Int(v2.z)) Then
    vectorIntEqual = True
Else
    vectorIntEqual = False
End If
End Function


Public Function vectorAdd(v1 As Vector3d, v2 As Vector3d) As Vector3d

With vectorAdd
    .x = v1.x + v2.x
    .y = v1.y + v2.y
    .z = v1.z + v2.z
End With

End Function
